package com.ekexiu.portal.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;

import com.ekexiu.portal.po.Assess;
import com.ekexiu.portal.po.Professor;
import com.ekexiu.portal.po.Resource;

@DAO
public abstract class AssessDao {
	@Insert
	public abstract int insert(Connection con, Assess assess) throws SQLException;
	
	@Update
	public abstract int update(Connection con, Assess assess) throws SQLException;
	
	public Assess query(Connection con,String assessId) throws SQLException{
        int index = 1;
        String sql = "SELECT ASSESS_ID,STAR_LEVEL,ASSESS.DESCP,ASSESS.OPERATION_ID,ASSESS.RESOURCE_ID,"
        		+ " ASSESS.PROFESSOR_ID,RESOURCE_NAME,PROFESSOR.NAME,ASSESS.CREATE_TIME "
        		+ " FROM ASSESS INNER JOIN RESOURCE ON ASSESS.RESOURCE_ID = RESOURCE.RESOURCE_ID "
        		+ " INNER JOIN PROFESSOR ON ASSESS.PROFESSOR_ID = PROFESSOR.ID "
        		+ " WHERE ASSESS_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,assessId);
            ResultSet rs = ps.executeQuery();
            try{
                if(rs.next()){
                    Assess assess = new Assess();
                    assess.setAssessId(rs.getString(1));
                    assess.setStarLevel(rs.getInt(2));
                    String descp = rs.getString(3);
                    if(rs.wasNull()){
                    	descp = null;
                    }
                    assess.setDescp(descp);
                    assess.setOperationId(rs.getString(4));
                    Resource resource = new Resource();
                    resource.setResourceId(rs.getString(5));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(6));
                    resource.setResourceName(rs.getString(7));
                    assess.setResource(resource);
                    professor.setName(rs.getString(8));
                    assess.setProfessor(professor);
                    assess.setCreateTime(rs.getString(9));
                    return assess;
                }else{
                    return null;
                }
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	public List<Assess> queryOper(Connection con,String operationId) throws SQLException{
        int index = 1;
        String sql = "SELECT ASSESS_ID,STAR_LEVEL,ASSESS.DESCP,ASSESS.OPERATION_ID,ASSESS.RESOURCE_ID,"
        		+ " ASSESS.PROFESSOR_ID,RESOURCE_NAME,PROFESSOR.NAME,ASSESS.CREATE_TIME "
        		+ " FROM ASSESS INNER JOIN RESOURCE ON ASSESS.RESOURCE_ID = RESOURCE.RESOURCE_ID "
        		+ " INNER JOIN PROFESSOR ON ASSESS.PROFESSOR_ID = PROFESSOR.ID "
        		+ " WHERE ASSESS.OPERATION_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,operationId);
            ResultSet rs = ps.executeQuery();
            try{
                List<Assess> assesses = new ArrayList<Assess>();
                while(rs.next()){
                    Assess assess =  new Assess();
                    assess.setAssessId(rs.getString(1));
                    assess.setStarLevel(rs.getInt(2));
                    String descp = rs.getString(3);
                    if(rs.wasNull()){
                    	descp = null;
                    }
                    assess.setDescp(descp);
                    assess.setOperationId(rs.getString(4));
                    Resource resource = new Resource();
                    resource.setResourceId(rs.getString(5));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(6));
                    resource.setResourceName(rs.getString(7));
                    assess.setResource(resource);
                    professor.setName(rs.getString(8));
                    assess.setProfessor(professor);
                    assess.setCreateTime(rs.getString(9));
                    assesses.add(assess);
                }
                return assesses;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	public List<Assess> queryRes(Connection con,String resourceId) throws SQLException{
        int index = 1;
        String sql = "SELECT ASSESS_ID,STAR_LEVEL,ASSESS.DESCP,ASSESS.OPERATION_ID,ASSESS.RESOURCE_ID,"
        		+ " ASSESS.PROFESSOR_ID,RESOURCE_NAME,PROFESSOR.NAME,ASSESS.CREATE_TIME "
        		+ " FROM ASSESS INNER JOIN RESOURCE ON ASSESS.RESOURCE_ID = RESOURCE.RESOURCE_ID "
        		+ " INNER JOIN PROFESSOR ON ASSESS.PROFESSOR_ID = PROFESSOR.ID "
        		+ " WHERE ASSESS.RESOURCE_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,resourceId);
            ResultSet rs = ps.executeQuery();
            try{
                List<Assess> assesses = new ArrayList<Assess>();
                while(rs.next()){
                    Assess assess =  new Assess();
                    assess.setAssessId(rs.getString(1));
                    assess.setStarLevel(rs.getInt(2));
                    String descp = rs.getString(3);
                    if(rs.wasNull()){
                    	descp = null;
                    }
                    assess.setDescp(descp);
                    assess.setOperationId(rs.getString(4));
                    Resource resource = new Resource();
                    resource.setResourceId(rs.getString(5));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(6));
                    resource.setResourceName(rs.getString(7));
                    assess.setResource(resource);
                    professor.setName(rs.getString(8));
                    assess.setProfessor(professor);
                    assess.setCreateTime(rs.getString(9));
                    assesses.add(assess);
                }
                return assesses;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	public List<Assess> queryPro(Connection con,String professorId) throws SQLException{
        int index = 1;
        String sql = "SELECT ASSESS_ID,STAR_LEVEL,ASSESS.DESCP,ASSESS.OPERATION_ID,ASSESS.RESOURCE_ID,"
        		+ " ASSESS.PROFESSOR_ID,RESOURCE_NAME,PROFESSOR.NAME,ASSESS.CREATE_TIME "
        		+ " FROM ASSESS INNER JOIN RESOURCE ON ASSESS.RESOURCE_ID = RESOURCE.RESOURCE_ID "
        		+ " INNER JOIN PROFESSOR ON ASSESS.PROFESSOR_ID = PROFESSOR.ID "
        		+ " WHERE ASSESS.PROFESSOR_ID = ?";
        PreparedStatement ps = con.prepareStatement(sql);
        try{
            ps.setString(index++,professorId);
            ResultSet rs = ps.executeQuery();
            try{
                List<Assess> assesses = new ArrayList<Assess>();
                while(rs.next()){
                    Assess assess =  new Assess();
                    assess.setAssessId(rs.getString(1));
                    assess.setStarLevel(rs.getInt(2));
                    String descp = rs.getString(3);
                    if(rs.wasNull()){
                    	descp = null;
                    }
                    assess.setDescp(descp);
                    assess.setOperationId(rs.getString(4));
                    Resource resource = new Resource();
                    resource.setResourceId(rs.getString(5));
                    Professor professor = new Professor();
                    professor.setId(rs.getString(6));
                    resource.setResourceName(rs.getString(7));
                    assess.setResource(resource);
                    professor.setName(rs.getString(8));
                    assess.setProfessor(professor);
                    assess.setCreateTime(rs.getString(9));
                    assesses.add(assess);
                }
                return assesses;
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
    }
	
	@DeleteWith
	@From(Assess.class)
	public abstract int delete(Connection con, String assessId) throws SQLException;
	
	@DeleteWith
	@From(Assess.class)
	public abstract int deleteRes(Connection con, String resourceId) throws SQLException;
	
	@DeleteWith
	@From(Assess.class)
	public abstract int deletePro(Connection con, String professorId) throws SQLException;
	
}
