package com.ekexiu.portal.notify;

public enum NotifyType {
	AGREE_LEAVE_MSG_AT_ANSWER("%s  点赞了您在回答 <span>%s</span> 下的留言",19, 2) ,
	AGREE_LEAVE_MSG_AT_PAPER("%s  点赞了您在论文 <span>%s</span> 下的留言",18, 2) ,
	AGREE_LEAVE_MSG_AT_PARENT("%s  点赞了您在专利 <span>%s</span> 下的留言",17, 2) ,
	AGREE_LEAVE_MSG_AT_ARTICLE("%s  点赞了您在文章 <span>%s</span> 下的留言",16, 2) ,
	REPLY_LEAVE_MSG_AT_ANSWER("%s  回复了您在回答 <span>%s</span> 下的留言",15, 2) ,
	REPLY_LEAVE_MSG_AT_PAPER("%s  回复了您在论文 <span>%s</span> 下的留言",14, 2) ,
	REPLY_LEAVE_MSG_AT_PARENT("%s  回复了您在专利 <span>%s</span> 下的留言",13, 2) ,
	REPLY_LEAVE_MSG_AT_ARTICLE("%s  回复了您在文章 <span>%s</span> 下的留言",12, 2) ,
	LEAVE_MSG_AT_ANSWER("%s  给您的回答 <span>%s</span> 留言了",11, 2) ,
	LEAVE_MSG_AT_PAPER("%s  给您的论文 <span>%s</span> 留言了",10, 2) ,
	LEAVE_MSG_AT_PARENT("%s  给您的专利 <span>%s</span> 留言了", 9, 2) ,
	LEAVE_MSG_AT_ARTICLE("%s  给您的文章 <span>%s</span> 留言了", 8, 2) ,
	AGREE_PAPER("%s 点赞了您的论文 <span>%s</span>", 7, 2) ,
	AGREE_PATENT("%s 点赞了您的专利 <span>%s</span>", 6, 2) ,
	INVITE_ANSWER("%s 邀请您回答问题 <span>%s</span>", 5, 2) ,
	ACCEPT_ANSWER("%s 点赞了您在问题 <span>%s</span> 下的回答", 4, 2) ,
	ANSWER_QUESTION("%s 回答了您的提问 <span>%s</span>", 3, 2) ,
	AGREE_ARTICLE("%s 点赞了您的文章 <span>%s</span>", 2, 2) ,
	AGREE_RESEARCH_AREA("%s 点赞了您的研究方向 <span>%s</span>", 1, 2) ,
	WATCH_USER("<span>%s</span> 关注了您", 0, 1);

	private String template;
	private int type;
	private int paramSize;

	NotifyType(String template, int type, int paramSize) {
		this.template = template;
		this.type = type;
		this.paramSize = paramSize;
	}

	public String getTemplate() {
		return template;
	}

	public int getType() {
		return type;
	}

	public String format(String user, String title) {
		return paramSize == 1 ? String.format(this.template, html(user)) : String.format(this.template, html(user), html(title));
	}

	private static String html(String html) {
		html = html.replaceAll("&", "&amp;");
		html = html.replace("\"", "&quot;"); // "
		html = html.replace("\t", "&nbsp;&nbsp;");// 替换跳格
		html = html.replace(" ", "&nbsp;");// 替换空格
		html = html.replace("<", "&lt;");
		html = html.replaceAll(">", "&gt;");
		return html;
	}

}
