package com.ekexiu.portal.platform;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;


@Path("/platform/sync")
public class PlatformSyncService {

	
	@Autowrie
	private PlatformDao platformDao;

	public PlatformDao getPlatformDao() {
		return platformDao;
	}

	public void setPlatformDao(PlatformDao platformDao) {
		this.platformDao = platformDao;
	}
	
	
	@Post
	@Path("/insert")
	public void insert(@JdbcConn(true) Connection con,PlatformDemand pd)throws SQLException{
		platformDao.insert(con, pd);
	} 
	@Post
	@Path("/update")
	public void update(@JdbcConn(true) Connection con,PlatformDemand pd)throws SQLException{
		platformDao.update(con, pd);
	} 
	@Post
	@Path("/delay")
	public void delay(@JdbcConn(true) Connection con,String id,String pid,String day)throws SQLException{
		platformDao.delay(con,pid,id,day);
	}
	@Post
	@Path("/delete")
	public void delete(@JdbcConn(true) Connection con,String id,String pid)throws SQLException{
		platformDao.deleteDemand(con,pid,id);
	}
	
	@Get
	@Path("/list")
	public List<PlatformDemandProfessor> queryPlatform(@JdbcConn Connection con,String pid,String btime,String etime)throws SQLException{
		return platformDao.queryPdfList(con, pid, btime, etime);
	}
}
