package com.ekexiu.portal.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;

@Table
@PrimaryKey("id")
public class Demand implements CreateTimeSupported,ModifyTimeSupported {
	private String id;
	private String title;
	private String province;
	private String city;
	private String cost;
	private String duration;
	private String invalidDay;
	private String contactNum;
	
	private String state;
	private String orgName;
	private String creator;
	private String createTime;
	private String modifyTime;
	private String descp;
	private String source;
	
	
	private long pageViews;
	private long shareId;
	
	/**
	 * id 主键
	 * @return
	 */
	@Column(DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	/**
	 * 需求主题
	 * @return
	 */
	@Column(dbType="TEXT",handlerClass=StringHandler.class,insertable=true,nullable=false,queryable=true,renewable=false)
	public String getTitle() {
		return title;
	}
	public void setTitle(String title) {
		this.title = title;
	}
	/**
	 * 所在省份
	 * @return
	 */
	@Column(DE.text_de)
	public String getProvince() {
		return province;
	}
	public void setProvince(String province) {
		this.province = province;
	}
	/**
	 * 所在省份
	 * @return
	 */
	@Column(DE.Text_de)
	public String getCity() {
		return city;
	}
	public void setCity(String city) {
		this.city = city;
	}
	/**
	 * 费用预算
	 * @return
	 */
	@Column(DE.singleChar)
	public String getCost() {
		return cost;
	}
	public void setCost(String cost) {
		this.cost = cost;
	}
	/**
	 * 预期时长 
	 * @return
	 */
	@Column(DE.singleChar)
	public String getDuration() {
		return duration;
	}
	public void setDuration(String duration) {
		this.duration = duration;
	}
	/**
	 * 有效期
	 * @return
	 */
	@Column(DE.date_de)
	public String getInvalidDay() {
		return invalidDay;
	}
	public void setInvalidDay(String invalidDay) {
		this.invalidDay = invalidDay;
	}

	/**
	 * 联系电话
	 * @return
	 */
	@Column(DE.text_de)
	public String getContactNum() {
		return contactNum;
	}
	public void setContactNum(String contactNum) {
		this.contactNum = contactNum;
	}
	/**
	 * 状态  0:过期的,1:发布中的 2:完成的 3:关闭的,
	 * @return
	 */
	@Column(DE.singleChar)
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	/**
	 * 发布人发布时所在机构
	 * @return
	 */
	@Column(DE.text_de)
	public String getOrgName() {
		return orgName;
	}
	public void setOrgName(String orgName) {
		this.orgName = orgName;
	}
	
	/**
	 * 发布来源
	 * @return
	 */
	@Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=false,queryable=true,renewable=false)	
	public String getSource() {
		return source;
	}
	public void setSource(String source) {
		this.source = source;
	}
	/**
	 * 发布人ID
	 * @return
	 */
	@Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",insertable=true,nullable=false,queryable=true,renewable=true)
	public String getCreator() {
		return creator;
	}
	public void setCreator(String creator) {
		this.creator = creator;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}
	/**
	 * 内容
	 */
	@Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=false,renewable=false,queryable=true)
	public String getDescp() {
		return descp;
	}
	public void setDescp(String descp) {
		this.descp = descp;
	}
	@Column(handlerClass=LongHandler.class,dbType="INT8",fixSqlValueWithInsert="0",insertable=true,nullable=false,renewable=false,queryable=true)
	public long getPageViews() {
		return pageViews;
	}
	public void setPageViews(long pageViews) {
		this.pageViews = pageViews;
	}
	@Column(DE.bigSerial)
	public long getShareId() {
		return shareId;
	}
	public void setShareId(long shareId) {
		this.shareId = shareId;
	}
}
