package com.ekexiu.portal.team;

import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;

/**
 * Created by TT on 2019/7/8.
 */
@Table(descp = "团队表")
@PrimaryKey("id")
public class Team implements CreateTimeSupported, ModifyTimeSupported {
    private String id;
    private String name;
    private String orgName;
    private String province;
    private String city;
    private String secretary;
    private String chief;
    private String subject;//学术领域
    private String industry;//行业领域
    private String descp;
    private String status;
    private String certify;


    private String createTime;
    private String modifyTime;

    @Column(DE.id_32)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Column(descp = "团队名称",value = DE.text_de)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(descp = "所属企业名称",value = DE.text_de)
    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    @Column(descp = "所在省份",value = DE.text_de)
    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    @Column(descp = "所在城市",value = DE.text_de)
    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    @Column(descp = "团队秘书",value = DE.refid_32)
    public String getSecretary() {
        return secretary;
    }

    public void setSecretary(String secretary) {
        this.secretary = secretary;
    }

    @Column(descp = "团队首席专家",value = DE.REFID_32)
    public String getChief() {
        return chief;
    }

    public void setChief(String chief) {
        this.chief = chief;
    }

    @Column(descp = "学术领域",value = DE.Text_de)
    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    @Column(descp = "行业领域",value = DE.Text_de)
    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    @Column(descp = "团队简介",value = DE.Text_de)
    public String getDescp() {
        return descp;
    }

    public void setDescp(String descp) {
        this.descp = descp;
    }

    @Column(descp = "团队状态  0：已删除 1待审核 2审核失败 3审核通过",value = DE.SingleChar)
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Column(descp = "团队材料",value = DE.Text_de)
    public String getCertify() {
        return certify;
    }

    public void setCertify(String certify) {
        this.certify = certify;
    }

    @Override
    public String getCreateTime() {
        return createTime;
    }

    @Override
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    @Override
    public String getModifyTime() {
        return modifyTime;
    }

    @Override
    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }
}
