package com.ekexiu.portal.views.handler.db;


import com.ekexiu.portal.views.handler.LogHandler;
import org.jfw.util.log.LogFactory;
import org.jfw.util.log.Logger;

import javax.sql.DataSource;
import java.sql.Connection;
import java.sql.SQLException;

public abstract class DbLogHandler extends LogHandler {

	private static final Logger log = LogFactory.getLog(DbLogHandler.class);

	private DataSource dataSource;
	protected Connection con;

	public DataSource getDataSource() {
		return dataSource;
	}

	public void setDataSource(DataSource dataSource) {
		this.dataSource = dataSource;
	}

	public abstract boolean pre() throws Exception;;
	public abstract void stroe() throws SQLException;
	public abstract void afterCommit();
	@Override
	synchronized public void run() {
		try {
			if(!this.pre())return;
			this.con = this.dataSource.getConnection();
			try {
				this.stroe();
				con.commit();
				this.afterCommit();
			}catch(Exception e){
				try {
					con.rollback();
				} catch (Exception ee) {
				}
				throw e;
			}
			finally {
				try {
					con.close();
				} catch (Exception e) {
				}
			}
		} catch (Exception e) {
			log.error("hand runnable.run error",e);
		}
	}
}
