package com.ekexiu.portal.ware;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.portal.basepo.CreateTimeSupported;
import com.ekexiu.portal.basepo.ModifyTimeSupported;

@PrimaryKey("id")
@Table
public class Ware implements CreateTimeSupported, ModifyTimeSupported{
	private String id;
	private String name;
	/**
	 * 关键字
	 */
	private String keywords;

	/**
	 * 服务内容
	 */
	private String cnt;
	/**
	 * 合作备注
	 */
	private String cooperation;
	/**
	 * 详细描述
	 */
	private String descp;
	/**
	 * 类型：1：个人  2：企业
	 */
	private String category;
	/**
	 * 发布人
	 */
	private String owner;
	
	private String images;
	/**
	 * 状态  0：删除，1:发布的 ，2：草稿
	 */
	private String state;
	/**
	 * 创建时间
	 */
	private String createTime;
	/**
	 * 最后修改时间 
	 */
	private String modifyTime;
	private long shareId;
	private long pageViews;
	private long sortFirst;
	
	
	
	
	
	
	@Column(handlerClass=LongHandler.class,dbType="INT8",nullable=true,renewable=false,fixSqlValueWithInsert="0")
	public long getPageViews() {
		return pageViews;
	}
	public void setPageViews(long pageViews) {
		this.pageViews = pageViews;
	}
	@Column(DE.id_32)
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	@Column(DE.text_de)
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	@Column(DE.Text_de)
	public String getKeywords() {
		return keywords;
	}
	public void setKeywords(String keywords) {
		this.keywords = keywords;
	}
	@Column(DE.Text_de)
	public String getCnt() {
		return cnt;
	}
	public void setCnt(String context) {
		this.cnt = context;
	}
	@Column(DE.Text_de)
	public String getCooperation() {
		return cooperation;
	}
	public void setCooperation(String cooperation) {
		this.cooperation = cooperation;
	}
	@Column(DE.Text_de)
	public String getDescp() {
		return descp;
	}
	public void setDescp(String descp) {
		this.descp = descp;
	}
	@Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",insertable=true,nullable=false,queryable=true,renewable=false)
	public String getCategory() {
		return category;
	}
	public void setCategory(String category) {
		this.category = category;
	}
	@Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=false,queryable=true,renewable=false)
	public String getOwner() {
		return owner;
	}
	public void setOwner(String owner) {
		this.owner = owner;
	}
	@Column(DE.Text_de)
	public String getImages() {
		return images;
	}
	public void setImages(String images) {
		this.images = images;
	}
	@Column(DE.singleChar)
	public String getState() {
		return state;
	}
	public void setState(String state) {
		this.state = state;
	}
	public String getCreateTime() {
		return createTime;
	}
	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}
	public String getModifyTime() {
		return modifyTime;
	}
	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}

	@Column(DE.bigSerial)
	public long getShareId() {
		return shareId;
	}
	public void setShareId(long shareId) {
		this.shareId = shareId;
	}
	@Column(handlerClass=LongHandler.class,dbType="INT8",fixSqlValueWithInsert="0",insertable=true,renewable = false,queryable=true,nullable=false)
	public long getSortFirst() {
		return sortFirst;
	}
	public void setSortFirst(long sortFirst) {
		this.sortFirst = sortFirst;
	}
	
}
